/****** Update Lockview 5.x Database to v5.5 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
-- 15K Users Update --------------
ALTER TABLE AccessRights ALTER COLUMN SlotNum INT NOT NULL
UPDATE AccessRights SET SlotNum = 99999 WHERE SlotNum = 9999
GO
ALTER TABLE zTmpAR ALTER COLUMN SlotNum INT NOT NULL
GO
ALTER TABLE [dbo].[lsFirmware] DROP CONSTRAINT [PK_lsFirmware]
GO
ALTER TABLE [dbo].[lsFirmware] ADD CONSTRAINT [PK2_lsFirmware] PRIMARY KEY CLUSTERED 
(
	[Hardware] ASC,
	[codeID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, IGNORE_DUP_KEY = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON)
GO
ALTER TABLE [dbo].[lsFirmware] DROP CONSTRAINT [IX_lsFirmware_Key]
GO

-- Add NarcID tables (No 'GO' after each; want all to succeed else all fail) -------------
CREATE TABLE [dbo].[Incidents](
	[IncidentNumber] [nvarchar](50) NOT NULL,
	[IncidentDate] [datetime] NOT NULL,
	[Details] [nvarchar](max) NULL CONSTRAINT [DF_Incidents_Notes]  DEFAULT (''),
	[AddBy] [nvarchar](50) NOT NULL,
	[AddDate] [datetime] NOT NULL,
	[ModifyBy] [nvarchar](50) NULL,
	[ModifyDate] [datetime] NULL,
	[Deleted] [bit] NOT NULL CONSTRAINT [DF_Incidents_Deleted] DEFAULT ((0)),
 CONSTRAINT [PK_Incident] PRIMARY KEY CLUSTERED 
(
	[IncidentNumber] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]

CREATE TABLE [dbo].[Containers](
	[ID] [int] IDENTITY(1,1) NOT NULL,
	[ContainerName] [nvarchar](50) NOT NULL,
	[Deleted] [bit] NOT NULL CONSTRAINT [DF_Containers_Deleted]  DEFAULT ((0)),
 CONSTRAINT [PK_Container] PRIMARY KEY CLUSTERED 
(
	[ID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]

CREATE TABLE [dbo].[DrugTypes](
	[ID] [int] IDENTITY(1,1) NOT NULL,
	[NarcName] [nvarchar](50) NOT NULL,
	[NarcName6] [nvarchar](6) NOT NULL,
	[Deleted] [bit] NOT NULL CONSTRAINT [DF_DrugTypes_Deleted]  DEFAULT ((0)),
 CONSTRAINT [PK_NarcName] PRIMARY KEY CLUSTERED 
(
	[ID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]

CREATE TABLE [dbo].[Drugs](
	[TagNumber] [nvarchar](50) NOT NULL,
	[DrugTypeID] [int] NOT NULL,
	[ContainerID] [int] NULL,
	[Manufacturer] [nvarchar](50) NULL,
	[Lot] [nvarchar](50) NULL,
	[ExpirationDate] [date] NULL,
	[AddDate] [datetime] NULL,
	[AddBy] [nvarchar](50) NULL,
	[ModifyDate] [datetime] NULL,
	[ModifyBy] [nvarchar](50) NULL,
	[IncidentNumber] [nvarchar](50) NULL,
	[EPC] [nvarchar](50) NULL,
	[Deleted] [bit] NOT NULL CONSTRAINT [DF_Drugs_Deleted] DEFAULT ((0)),
	[CurrentState] [nvarchar](200) NULL,
	[ReasonInactive] [nvarchar](200) NULL,
	[Active] [bit] NOT NULL CONSTRAINT [DF_Drugs_Active] DEFAULT ((1)),
 CONSTRAINT [PK_Drugs] PRIMARY KEY CLUSTERED 
(
	[TagNumber] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]

CREATE TABLE [dbo].[Fates](
	[Code] [nvarchar](4) NOT NULL,
	[Description] [nvarchar](50) NOT NULL,
	[Active] [bit] NOT NULL CONSTRAINT [DF_Fates_Active]  DEFAULT ((1)),
	[Deleted] [bit] NOT NULL CONSTRAINT [DF_Fates_Deleted]  DEFAULT ((0)),
 CONSTRAINT [PK_Fates] PRIMARY KEY CLUSTERED 
(
	[Code] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]

CREATE TABLE [dbo].[DrugLogs](
	[ID] [int] IDENTITY(1,1) NOT NULL,
	[TagNumber] [nvarchar](50) NULL,
	[IncidentNumber] [nvarchar](50) NULL CONSTRAINT [DF_DrugLogs_IncidentNumber]  DEFAULT (NULL),
	[LockSN] [nvarchar](50) NULL,
	[Username] [nvarchar](50) NULL,
	[TypeOfAccess] [nvarchar](50) NULL,
	[AccessCodeUsed] [nvarchar](50) NULL,
	[Status] [nvarchar](200) NULL,
	[EventDate] [datetime] NOT NULL,
	[InsertDate] [datetime] NOT NULL CONSTRAINT [DF_DrugLogs_InsertDate]  DEFAULT (getdate()),
 	[LockName] [nvarchar](50) NULL,
CONSTRAINT [PK_DrugLog] PRIMARY KEY NONCLUSTERED 
(
	[ID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]

CREATE TABLE [dbo].[DrugLogsArchive](
	[ID] [int] NOT NULL,
	[TagNumber] [nvarchar](50) NULL,
	[IncidentNumber] [nvarchar](50) NULL,
	[LockSN] [nvarchar](50) NULL,
	[Username] [nvarchar](50) NULL,
	[TypeOfAccess] [nvarchar](50) NULL,
	[AccessCodeUsed] [nvarchar](50) NULL,
	[Status] [nvarchar](200) NULL,
	[EventDate] [datetime] NOT NULL,
	[InsertDate] [datetime] NOT NULL,
	[LockName] [nvarchar](50) NULL
) ON [PRIMARY]

CREATE TABLE [dbo].[Inventories](
	[TagNumber] [nvarchar](50) NOT NULL,
	[LockSN] [nvarchar](50) NOT NULL,
	[LocalID] [nvarchar](4) NOT NULL,
	[Tamper] [bit] NOT NULL CONSTRAINT [DF_Inventories_Tamper] DEFAULT ((0)),
	[Limbo] [bit] NOT NULL CONSTRAINT [DF_Inventories_Limbo] DEFAULT ((0)),
	[FateCode] [nvarchar](4) NULL CONSTRAINT [DF_Inventories_FateCode] DEFAULT (NULL),
	[NotifyIfAbsent] [bit] NOT NULL CONSTRAINT [DF_Inventories_NotifyIfAbsent] DEFAULT ((1)),
	[LastSeenDate] [datetime] NOT NULL CONSTRAINT [DF_LastSeenDate]  DEFAULT (getdate())
) ON [PRIMARY]

CREATE TABLE [dbo].[ReportNarc](
	[RepID] [int] NOT NULL,
	[ExpirationNotice] [smallint] NULL,
	[NextStartTimeUnusualUse] [datetime] NULL,
	[NextStartTimeUnaccountedFor] [datetime] NULL,
 CONSTRAINT [PK_ReportNarc] PRIMARY KEY CLUSTERED 
(
	[RepID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]

/****** DROP PRIMARY KEYS ********/
ALTER TABLE [dbo].[EntryLogArchive] DROP CONSTRAINT [PK_EntryLogArchive]
GO

/****** CREATE INDEXES ******/
CREATE NONCLUSTERED INDEX [IDX_EventDate_Tag] ON [dbo].[DrugLogs]
(
	[EventDate] ASC
)
INCLUDE ( 	[TagNumber]) WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
GO

CREATE NONCLUSTERED INDEX [IDX_DLA_EventDate_Tag_] ON [dbo].[DrugLogsArchive]
(
	[EventDate] ASC
)
INCLUDE ( 	[TagNumber]) WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
GO

CREATE NONCLUSTERED INDEX [IDX_IncidentNumber] ON [dbo].[Drugs]
(
	[IncidentNumber] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
GO

CREATE NONCLUSTERED INDEX [IDX_LockSN] ON [dbo].[Inventories]
(
	[LockSN] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
GO

CREATE CLUSTERED INDEX [IDX_TagNumber] ON [dbo].[DrugLogs]
(
	[TagNumber] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
GO

CREATE NONCLUSTERED INDEX [IDX_IncidentNumber] ON [dbo].[DrugLogs]
(
	[IncidentNumber] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
GO

CREATE NONCLUSTERED INDEX [IDX_LockSN] ON [dbo].[DrugLogs]
(
	[LockSN] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
GO

CREATE CLUSTERED INDEX [IDX_TagNumber] ON [dbo].[DrugLogsArchive]
(
	[TagNumber] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
GO

CREATE NONCLUSTERED INDEX [IDX_IncidentNumber] ON [dbo].[DrugLogsArchive]
(
	[IncidentNumber] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
GO

CREATE NONCLUSTERED INDEX [IDX_LockSN] ON [dbo].[DrugLogsArchive]
(
	[LockSN] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
GO

CREATE NONCLUSTERED INDEX [IDX_DrugType] ON [dbo].[Drugs]
(
	[DrugTypeID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
GO

CREATE NONCLUSTERED INDEX [IDX_UserLog] ON [dbo].[EntryLog]
(
	[Username] ASC,
	[StatusCode] ASC
)
INCLUDE ( 	[RecordID],
	[SessionID],
	[TypeofAccess],
	[Status],
	[DateOfEntry],
	[TimeOfEntry]) WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
GO

/****** CREATE FOREIGN KEYS ******/
ALTER TABLE [dbo].[Inventories]  WITH CHECK ADD  CONSTRAINT [FK_Drugs_Inventories] FOREIGN KEY([TagNumber])
REFERENCES [dbo].[Drugs] ([TagNumber])
ALTER TABLE [dbo].[Inventories] CHECK CONSTRAINT [FK_Drugs_Inventories]
GO

ALTER TABLE [dbo].[Inventories]  WITH CHECK ADD  CONSTRAINT [FK_Locks_Inventories] FOREIGN KEY([LockSN])
REFERENCES [dbo].[Locks] ([LockSN])
ALTER TABLE [dbo].[Inventories] CHECK CONSTRAINT [FK_Locks_Inventories]
GO

ALTER TABLE [dbo].[Drugs]  WITH CHECK ADD  CONSTRAINT [FK_Containers_Drugs] FOREIGN KEY([ContainerID])
REFERENCES [dbo].[Containers] ([ID])
ALTER TABLE [dbo].[Drugs] CHECK CONSTRAINT [FK_Containers_Drugs]
GO

ALTER TABLE [dbo].[Drugs]  WITH CHECK ADD  CONSTRAINT [FK_DrugTypes_Drugs] FOREIGN KEY([DrugTypeID])
REFERENCES [dbo].[DrugTypes] ([ID])
ALTER TABLE [dbo].[Drugs] CHECK CONSTRAINT [FK_DrugTypes_Drugs]
GO

ALTER TABLE [dbo].[Drugs]  WITH CHECK ADD  CONSTRAINT [FK_Incidents_Drugs] FOREIGN KEY([IncidentNumber])
REFERENCES [dbo].[Incidents] ([IncidentNumber])
ALTER TABLE [dbo].[Drugs] CHECK CONSTRAINT [FK_Incidents_Drugs]
GO

ALTER TABLE [dbo].[DrugLogs]  WITH CHECK ADD  CONSTRAINT [FK_Drugs_DrugLogs] FOREIGN KEY([TagNumber])
REFERENCES [dbo].[Drugs] ([TagNumber])
ALTER TABLE [dbo].[DrugLogs] CHECK CONSTRAINT [FK_Drugs_DrugLogs]
GO

ALTER TABLE [dbo].[DrugLogs]  WITH CHECK ADD  CONSTRAINT [FK_Incidents_DrugLogs] FOREIGN KEY([IncidentNumber])
REFERENCES [dbo].[Incidents] ([IncidentNumber])
ALTER TABLE [dbo].[DrugLogs] CHECK CONSTRAINT [FK_Incidents_DrugLogs]
GO

ALTER TABLE [dbo].[DrugLogs]  WITH CHECK ADD  CONSTRAINT [FK_Locks_DrugLogs] FOREIGN KEY([LockSN])
REFERENCES [dbo].[Locks] ([LockSN])
ALTER TABLE [dbo].[DrugLogs] CHECK CONSTRAINT [FK_Locks_DrugLogs]
GO

ALTER TABLE recipients alter column notifyof VARCHAR(20) NOT NULL
GO
UPDATE recipients set notifyof = 'OYTABX(05)UM' where recipname = 'LockView App' AND notifyof = 'OYTAB'
GO
ALTER TABLE DbKeys ADD CONSTRAINT [DF_DbKeyDate]  DEFAULT (GETDATE()) FOR [DbKeyDate]
GO
UPDATE DbKeys SET DbKeyDate = GETDATE() WHERE DbKeyDate IS NULL
GO
ALTER TABLE LANMRU ALTER COLUMN PSK VARCHAR(160) NOT NULL
GO

/***************** Lockview Data Initialization BEGIN *************************************/
INSERT INTO Fates (Code,  Description, Active) VALUES('6272', 'Broken', 1)
INSERT INTO Fates (Code,  Description, Active) VALUES('636e', 'Consumed', 1)
INSERT INTO Fates (Code,  Description, Active) VALUES('696e', 'Incident', 0)
INSERT INTO Fates (Code,  Description, Active) VALUES('6c73', 'Lost', 1)
INSERT INTO Fates (Code,  Description, Active) VALUES('7870', 'Expired', 1)
INSERT INTO Fates (Code,  Description, Active) VALUES('7472', 'Transfer', 1)
GO
SET IDENTITY_INSERT [dbo].[DrugTypes] ON
INSERT INTO DrugTypes (ID,NarcName,NarcName6) VALUES(1, 'fentaNYL', 'fentnl')
INSERT INTO DrugTypes (ID,NarcName,NarcName6) VALUES(2, 'Midazolam', 'midzlm')
INSERT INTO DrugTypes (ID,NarcName,NarcName6) VALUES(3, 'Morphine', 'morphn')
INSERT INTO DrugTypes (ID,NarcName,NarcName6) VALUES(4, 'HYDROmorphone', 'hymrph')
INSERT INTO DrugTypes (ID,NarcName,NarcName6) VALUES(5, 'Ketamine', 'ketmin')
INSERT INTO DrugTypes (ID,NarcName,NarcName6) VALUES(6, 'Meperidine', 'meprdn')
INSERT INTO DrugTypes (ID,NarcName,NarcName6) VALUES(7, 'diazePAM', 'diazpm')
INSERT INTO DrugTypes (ID,NarcName,NarcName6) VALUES(8, 'LORazepam', 'lorzpm')
INSERT INTO DrugTypes (ID,NarcName,NarcName6) VALUES(9, 'Generic', 'generc')
SET IDENTITY_INSERT [dbo].[DrugTypes] OFF
GO
SET IDENTITY_INSERT [dbo].[Containers] ON
INSERT INTO Containers (ID, ContainerName) VALUES(1, '(none)')
INSERT INTO Containers (ID, ContainerName) VALUES(2, 'single dose vial 1mL')
INSERT INTO Containers (ID, ContainerName) VALUES(3, 'ampule 1mL')
INSERT INTO Containers (ID, ContainerName) VALUES(4, 'preloaded syringe 1mL')
INSERT INTO Containers (ID, ContainerName) VALUES(5, 'single dose vial 2mL')
INSERT INTO Containers (ID, ContainerName) VALUES(6, 'ampule 2mL')
INSERT INTO Containers (ID, ContainerName) VALUES(7, 'preloaded syringe 2mL')
INSERT INTO Containers (ID, ContainerName) VALUES(8, 'single dose vial 5mL')
INSERT INTO Containers (ID, ContainerName) VALUES(9, 'ampule 5mL')
INSERT INTO Containers (ID, ContainerName) VALUES(10, 'preloaded syringe 5mL')
INSERT INTO Containers (ID, ContainerName) VALUES(11, 'vial 20mL')
SET IDENTITY_INSERT [dbo].[Containers] OFF
GO
/***************** Lockview Data Initialization END *************************************/

-- Replace ScriptLevel in DbKeys 
DELETE FROM DbKeys WHERE DbKeyName = 'ScriptLevel'
INSERT INTO DbKeys (DbKeyName, DbKeyValue) VALUES('ScriptLevel','553')
GO
INSERT INTO DbKeys (DbKeyName, DbKeyValue) VALUES('Upgrade200130','Lockview 5.5')
GO

